=== renamed file 'data/new.menu.in' => 'data/whats_new.menu.in'
=== modified file 'po/POTFILES.in'
--- po/POTFILES.in	2012-01-19 12:48:54 +0000
+++ po/POTFILES.in	2012-01-31 10:16:26 +0000
@@ -4,7 +4,7 @@
 data/ubuntu-software-center.desktop.in
 data/unbranded-software-center.desktop.in
 [type: gettext/xml] data/featured.menu.in
-[type: gettext/xml] data/new.menu.in
+[type: gettext/xml] data/whats_new.menu.in
 [type: gettext/xml] data/software-center.menu.in
 softwarecenter/backend/channel.py
 softwarecenter/backend/login_sso.py

=== modified file 'setup.cfg'
--- setup.cfg	2011-07-21 15:28:53 +0000
+++ setup.cfg	2012-01-31 10:16:26 +0000
@@ -14,7 +14,7 @@
             ),
 	    ("share/app-install/menu.d/",	
 	     ("data/featured.menu.in",
-	      "data/new.menu.in",
+	      "data/whats_new.menu.in",
 	      "data/top-rated.menu.in",
 	     )
 	    ),

=== modified file 'softwarecenter/backend/piston/sreclient_pristine.py'
--- softwarecenter/backend/piston/sreclient_pristine.py	2012-01-06 09:11:38 +0000
+++ softwarecenter/backend/piston/sreclient_pristine.py	2012-01-31 10:16:26 +0000
@@ -7,7 +7,7 @@
 AUTHENTICATED_API_SCHEME = 'https'
 
 class SoftwareCenterRecommenderAPI(PistonAPI):
-    default_service_root = 'http://localhost:8000/api/2.0'
+    default_service_root = 'http://localhost:8000/api/1.0'
 
     @returns_json
     def server_status(self):

=== modified file 'softwarecenter/enums.py'
--- softwarecenter/enums.py	2012-01-20 10:24:51 +0000
+++ softwarecenter/enums.py	2012-01-31 10:16:26 +0000
@@ -35,7 +35,8 @@
 BUY_SOMETHING_HOST_ANONYMOUS = os.environ.get("SOFTWARE_CENTER_AGENT_HOST") or os.environ.get("SOFTWARE_CENTER_BUY_HOST") or "http://software-center.ubuntu.com"
 
 # recommender
-RECOMMENDER_HOST = os.environ.get("SOFTWARE_CENTER_RECOMMENDER_HOST") or "https://recommender.software-center.ubuntu.com"
+RECOMMENDER_HOST = os.environ.get("SOFTWARE_CENTER_RECOMMENDER_HOST") or "https://recommender.ubuntu.com"
+#RECOMMENDER_HOST = os.environ.get("SOFTWARE_CENTER_RECOMMENDER_HOST") or "https://rec.staging.ubuntu.com"
 
 # for the sso login
 UBUNTU_SSO_SERVICE = os.environ.get(

=== modified file 'softwarecenter/ui/gtk3/views/catview_gtk.py'
--- softwarecenter/ui/gtk3/views/catview_gtk.py	2012-01-04 10:24:54 +0000
+++ softwarecenter/ui/gtk3/views/catview_gtk.py	2012-01-31 02:40:49 +0000
@@ -52,6 +52,7 @@
 from softwarecenter.db.utils import get_query_for_pkgnames
 from softwarecenter.distro import get_distro
 from softwarecenter.backend.scagent import SoftwareCenterAgent
+from softwarecenter.backend.recommends import RecommenderAgent
 
 LOG=logging.getLogger(__name__)
 
@@ -248,10 +249,9 @@
         self.right_column = Gtk.Box.new(Gtk.Orientation.VERTICAL, self.SPACING)
         self.top_hbox.pack_start(self.right_column, True, True, 0)
 
-        self._append_new()
-        #~ self._append_recommendations()
+        self._append_whats_new()
         self._append_top_rated()
-
+        self._append_recommended_for_you()
         self._append_appcount()
 
         #self._append_video_clips()
@@ -363,18 +363,18 @@
             cat_vbox.pack_start(label, False, False, 0)
         return
 
-    def _get_toprated_category_content(self):
-        toprated_cat = get_category_by_name(self.categories, 
-                                            u"Top Rated")  # unstranslated name
-        if toprated_cat is None:
-            LOG.warn("No 'toprated' category found!!")
+    def _get_top_rated_category_content(self):
+        top_rated_cat = get_category_by_name(self.categories, 
+                                             u"Top Rated")  # untranslated name
+        if top_rated_cat is None:
+            LOG.warn("No 'top_rated' category found!!")
             return None, []
 
         enq = AppEnquire(self.cache, self.db)
         app_filter = AppFilter(self.db, self.cache)
-        enq.set_query(toprated_cat.query,
+        enq.set_query(top_rated_cat.query,
                       limit=TOP_RATED_CAROUSEL_LIMIT,
-                      sortmode=toprated_cat.sortmode,
+                      sortmode=top_rated_cat.sortmode,
                       filter=app_filter,
                       nonapps_visible=NonAppVisibility.ALWAYS_VISIBLE,
                       nonblocking_load=False)
@@ -384,47 +384,48 @@
                                               self.cache,
                                               self.icons)
 
-        return toprated_cat, enq.get_documents()
+        return top_rated_cat, enq.get_documents()
 
-    def _update_toprated_content(self):
+    def _update_top_rated_content(self):
         # remove any existing children from the grid widget
-        self.toprated.remove_all()
-        # get toprated category and docs
-        toprated_cat, docs = self._get_toprated_category_content()
+        self.top_rated.remove_all()
+        # get top_rated category and docs
+        top_rated_cat, docs = self._get_top_rated_category_content()
         # display docs
-        self._add_tiles_to_flowgrid(docs, self.toprated,
+        self._add_tiles_to_flowgrid(docs, self.top_rated,
                                     TOP_RATED_CAROUSEL_LIMIT)
-        self.toprated.show_all()
-        return toprated_cat
+        self.top_rated.show_all()
+        return top_rated_cat
 
     def _append_top_rated(self):
-        self.toprated = FlowableGrid()
-        #~ self.featured.row_spacing = StockEms.SMALL
-        frame = FramedHeaderBox()
-        frame.set_header_label(_("Top Rated"))
-        frame.add(self.toprated)
-        self.toprated_frame = frame
-        self.right_column.pack_start(frame, True, True, 0)
+        self.top_rated = FlowableGrid()
+        #~ self.top_rated.row_spacing = StockEms.SMALL
+        self.top_rated_frame = FramedHeaderBox()
+        self.top_rated_frame.set_header_label(_("Top Rated"))
+        self.top_rated_frame.add(self.top_rated)
+        self.right_column.pack_start(self.top_rated_frame, True, True, 0)
 
-        toprated_cat = self._update_toprated_content()
-        # only display the 'More' LinkButton if we have toprated content
-        if toprated_cat is not None:
-            frame.header_implements_more_button()
-            frame.more.connect('clicked', self.on_category_clicked, toprated_cat) 
+        top_rated_cat = self._update_top_rated_content()
+        # only display the 'More' LinkButton if we have top_rated content
+        if top_rated_cat is not None:
+            self.top_rated_frame.header_implements_more_button()
+            self.top_rated_frame.more.connect('clicked', 
+                               self.on_category_clicked, top_rated_cat) 
         return
 
-    def _get_new_category_content(self):
-        whatsnew_cat = get_category_by_name(self.categories, 
-                                            u"What\u2019s New") # unstranslated name
-        if whatsnew_cat is None:
-            LOG.warn("No 'new' category found!!")
+    def _get_whats_new_category_content(self):
+        whats_new_cat = get_category_by_name(
+                                        self.categories, 
+                                        u"What\u2019s New") # untranslated name
+        if whats_new_cat is None:
+            LOG.warn("No 'whats_new' category found!!")
             return None, []
 
         enq = AppEnquire(self.cache, self.db)
         app_filter = AppFilter(self.db, self.cache)
         app_filter.set_available_only(True)
         app_filter.set_not_installed_only(True)
-        enq.set_query(whatsnew_cat.query,
+        enq.set_query(whats_new_cat.query,
                       limit=8,
                       filter=app_filter,
                       sortmode=SortMethods.BY_CATALOGED_TIME,
@@ -436,36 +437,35 @@
                                               self.cache,
                                               self.icons)
 
-        return whatsnew_cat, enq.get_documents()
+        return whats_new_cat, enq.get_documents()
 
-    def _update_new_content(self):
+    def _update_whats_new_content(self):
         # remove any existing children from the grid widget
-        self.featured.remove_all()
-        # get toprated category and docs
-        whatsnew_cat, docs = self._get_new_category_content()
+        self.whats_new.remove_all()
+        # get top_rated category and docs
+        whats_new_cat, docs = self._get_whats_new_category_content()
         # display docs
-        self._add_tiles_to_flowgrid(docs, self.featured, 8)
-        self.featured.show_all()
-        return whatsnew_cat
-
-    def _append_new(self):
-        self.featured = FlowableGrid()
-        frame = FramedHeaderBox()
-        frame.set_header_label(_(u"What\u2019s New"))
-        frame.add(self.featured)
-        self.new_frame = frame
-
-        whatsnew_cat = self._update_new_content()
-        if whatsnew_cat is not None:
+        self._add_tiles_to_flowgrid(docs, self.whats_new, 8)
+        self.whats_new.show_all()
+        return whats_new_cat
+
+    def _append_whats_new(self):
+        self.whats_new = FlowableGrid()
+        self.whats_new_frame = FramedHeaderBox()
+        self.whats_new_frame.set_header_label(_(u"What\u2019s New"))
+        self.whats_new_frame.add(self.whats_new)
+
+        whats_new_cat = self._update_whats_new_content()
+        if whats_new_cat is not None:
             # only add to the visible right_frame if we actually have it
-            self.right_column.pack_start(frame, True, True, 0)
-            frame.header_implements_more_button()
-            frame.more.connect('clicked', self.on_category_clicked, whatsnew_cat) 
+            self.right_column.pack_start(self.whats_new_frame, True, True, 0)
+            self.whats_new_frame.header_implements_more_button()
+            self.whats_new_frame.more.connect('clicked', self.on_category_clicked, whats_new_cat) 
         return
 
     #~ def _append_recommendations(self):
         #~ featured_cat = get_category_by_name(self.categories, 
-                                            #~ u"Featured")  # unstranslated name
+                                            #~ u"Featured")  # untranslated name
 #~ 
         #~ enq = AppEnquire(self.cache, self.db)
         #~ app_filter = AppFilter(self.db, self.cache)
@@ -486,6 +486,112 @@
         #~ docs = enq.get_documents()
         #~ self._add_tiles_to_flowgrid(docs, self.featured, 12)
         #~ return
+        
+    def _get_recommended_for_you_category_content(self, pkgs):
+            
+        query = get_query_for_pkgnames(pkgs)
+        recommended_for_you_cat = Category(
+                               u"Recommended for You", 
+                               _("Recommended for You"),
+                               None, 
+                               query,
+                               flags=['available-only', 'not-installed-only'],
+                               item_limit=60)
+            
+        enq = AppEnquire(self.cache, self.db)
+        app_filter = AppFilter(self.db, self.cache)
+        app_filter.set_available_only(True)
+        app_filter.set_not_installed_only(True)
+        enq.set_query(recommended_for_you_cat.query,
+                      limit=60,
+                      filter=app_filter,
+                      sortmode=SortMethods.UNSORTED,
+                      nonapps_visible=NonAppVisibility.ALWAYS_VISIBLE,
+                      nonblocking_load=False)
+
+        if not hasattr(self, "helper"):
+            self.helper = AppPropertiesHelper(self.db,
+                                              self.cache,
+                                              self.icons)
+
+        return recommended_for_you_cat, enq.get_documents()
+        
+    def _recommend_top_result(self, recommender_agent, result_list):
+        
+        pkgs = []
+        for item in result_list['recommendations']:
+            pkgs.append(item['package_name'])
+        
+        ##### test data : TO BE REMOVED, obviously (test list of uninstalled apps)
+        pkgs = ['clementine', 'hedgewars', 'gelemental', 'nexuiz', 'fgo', 'musique', 'pybik', 'radiotray', 'cherrytree', 'phlipple']
+        #####    
+            
+        recommended_for_you_cat, docs = self._get_recommended_for_you_category_content(pkgs)
+        
+        # display docs
+        if len(docs) > 0:
+            self._add_tiles_to_flowgrid(docs, self.recommended_for_you, 8)
+            self.recommended_for_you.show_all()
+            self.recommended_for_you_frame.hide_spinner()
+            self.recommended_for_you_frame.more.connect('clicked',
+                                                        self.on_category_clicked,
+                                                        recommended_for_you_cat)
+        else:
+            # TODO: this test for zero docs is temporary and will not be
+            # needed once the recommendation service is up and running
+            self._hide_recommended_for_you()
+        return
+        
+    def _recommender_service_error(self, recommender_agent, error_type):
+        LOG.warn("Error while accessing the recommender service: %s" 
+                                                            % error_type)
+        # TODO: temporary, instead we display cached recommendations here
+        self._hide_recommended_for_you()
+
+    def _update_recommended_for_you_content(self):
+        # remove any existing children from the grid widget
+        self.recommended_for_you.remove_all()
+        self.recommended_for_you_frame.show_spinner()
+        
+        # get a list of top recommendations via the recommender agent
+        self.recommender_agent = RecommenderAgent()
+        self.recommender_agent.connect("recommend-top", self._recommend_top_result)
+        self.recommender_agent.connect("error", self._recommender_service_error)
+        self.recommender_agent.query_recommend_top()
+
+    def _append_recommended_for_you(self):
+    
+        # TODO: This space will initially contain an opt-in screen, and this
+        #       will update to the tile view of recommended apps when ready
+        #       see https://wiki.ubuntu.com/SoftwareCenter#Home_screen
+        self.bottom_hbox = Gtk.HBox(spacing=StockEms.SMALL)
+        bottom_hbox_alignment = Gtk.Alignment()
+        bottom_hbox_alignment.set_padding(0, 0, StockEms.MEDIUM-2, StockEms.MEDIUM-2)
+        bottom_hbox_alignment.add(self.bottom_hbox)
+        self.vbox.pack_start(bottom_hbox_alignment, False, False, 0)
+        
+        # TODO: During development, place the "Recommended for You" panel
+        #       at the bottom, but swap this with the Top Rated panel once
+        #       the recommended for you pieces are done and deployed
+        #       see https://wiki.ubuntu.com/SoftwareCenter#Home_screen
+        self.recommended_for_you = FlowableGrid()
+        self.recommended_for_you_frame = FramedHeaderBox()
+        self.recommended_for_you_frame.set_header_label(
+                                                _(u"Recommended for You"))
+        self.recommended_for_you_frame.add(self.recommended_for_you)
+        self.recommended_for_you_frame.header_implements_more_button()
+        self.bottom_hbox.pack_start(self.recommended_for_you_frame, 
+                                    True, True, 0)
+        
+        # get the recommendations from the recommender agent
+        self._update_recommended_for_you_content()
+        
+    def _hide_recommended_for_you(self):
+        # remove the listeners
+        self.recommender_agent.disconnect_by_func(self._recommend_top_result)
+        self.recommender_agent.disconnect_by_func(self._recommender_service_error)
+        # and hide the pane
+        self.recommended_for_you_frame.hide()
 
     def _update_appcount(self):
         enq = AppEnquire(self.cache, self.db)
@@ -523,8 +629,8 @@
             return
         self._supported_only = supported_only
 
-        self._update_toprated_content()
-        self._update_new_content()
+        self._update_top_rated_content()
+        self._update_whats_new_content()
         self._update_appcount()
         return
 
@@ -554,7 +660,8 @@
         # sections
         self.current_category = None
         self.departments = None
-        self.toprated = None
+        self.top_rated = None
+        self.recommended_for_you = None
         self.appcount = None
 
         # widgetry
@@ -563,7 +670,7 @@
         self.vbox.set_margin_top(StockEms.MEDIUM)
         return
 
-    def _get_sub_toprated_content(self, category):
+    def _get_sub_top_rated_content(self, category):
         app_filter = AppFilter(self.db, self.cache)
         self.enquire.set_query(category.query,
                                limit=TOP_RATED_CAROUSEL_LIMIT,
@@ -574,23 +681,24 @@
         return self.enquire.get_documents()
 
     @wait_for_apt_cache_ready # be consistent with new apps
-    def _update_sub_toprated_content(self, category):
-        self.toprated.remove_all()
+    def _update_sub_top_rated_content(self, category):
+        self.top_rated.remove_all()
         # FIXME: should this be m = "%s %s" % (_(gettext text), header text) ??
 	# TRANSLATORS: %s is a category name, like Internet or Development Tools
         m = _('Top Rated %(category)s') % { 'category' : GObject.markup_escape_text(self.header)}
-        self.toprated_frame.set_header_label(m)
-        docs = self._get_sub_toprated_content(category)
-        self._add_tiles_to_flowgrid(docs, self.toprated, TOP_RATED_CAROUSEL_LIMIT)
+        self.top_rated_frame.set_header_label(m)
+        docs = self._get_sub_top_rated_content(category)
+        self._add_tiles_to_flowgrid(docs, self.top_rated, 
+                                    TOP_RATED_CAROUSEL_LIMIT)
         return
 
-    def _append_sub_toprated(self):
-        self.toprated = FlowableGrid()
-        self.toprated.set_row_spacing(6)
-        self.toprated.set_column_spacing(6)
-        self.toprated_frame = FramedHeaderBox()
-        self.toprated_frame.pack_start(self.toprated, True, True, 0)
-        self.vbox.pack_start(self.toprated_frame, False, True, 0)
+    def _append_sub_top_rated(self):
+        self.top_rated = FlowableGrid()
+        self.top_rated.set_row_spacing(6)
+        self.top_rated.set_column_spacing(6)
+        self.top_rated_frame = FramedHeaderBox()
+        self.top_rated_frame.pack_start(self.top_rated, True, True, 0)
+        self.vbox.pack_start(self.top_rated_frame, False, True, 0)
         return
 
     def _update_subcat_departments(self, category, num_items):
@@ -637,14 +745,14 @@
         self.departments = FlowableGrid(paint_grid_pattern=False)
         self.departments.set_row_spacing(StockEms.SMALL)
         self.departments.set_column_spacing(StockEms.SMALL)
-        frame = FramedBox(spacing=StockEms.MEDIUM,
-                          padding=StockEms.MEDIUM)
+        self.departments_frame = FramedBox(spacing=StockEms.MEDIUM,
+                                           padding=StockEms.MEDIUM)
         # set x/y-alignment and x/y-expand
-        frame.set(0.5, 0.0, 1.0, 1.0)
-        frame.pack_start(self.subcat_label, False, False, 0)
-        frame.pack_start(self.departments, True, True, 0)
+        self.departments_frame.set(0.5, 0.0, 1.0, 1.0)
+        self.departments_frame.pack_start(self.subcat_label, False, False, 0)
+        self.departments_frame.pack_start(self.departments, True, True, 0)
         # append the departments section to the page
-        self.vbox.pack_start(frame, False, True, 0)
+        self.vbox.pack_start(self.departments_frame, False, True, 0)
         return
 
     def _update_appcount(self, appcount):
@@ -666,14 +774,14 @@
         # these methods add sections to the page
         # changing order of methods changes order that they appear in the page
         self._append_subcat_departments()
-        self._append_sub_toprated()
+        self._append_sub_top_rated()
         self._append_appcount()
         self._built = True
         return
 
     def _update_subcat_view(self, category, num_items=0):
         num_items = self._update_subcat_departments(category, num_items)
-        self._update_sub_toprated_content(category)
+        self._update_sub_top_rated_content(category)
         self._update_appcount(num_items)
         self.show_all()
         return

=== modified file 'softwarecenter/ui/gtk3/widgets/containers.py'
--- softwarecenter/ui/gtk3/widgets/containers.py	2011-10-27 20:48:15 +0000
+++ softwarecenter/ui/gtk3/widgets/containers.py	2012-01-31 02:40:49 +0000
@@ -495,15 +495,37 @@
 class FramedHeaderBox(FramedBox):
 
     MARKUP = '<b>%s</b>'
+    
+    # pages for the spinner notebook
+    (CONTENT,
+     SPINNER) = range(2)
 
-    def __init__(self, orientation=Gtk.Orientation.VERTICAL, spacing=0, padding=0):
+    def __init__(self, orientation=Gtk.Orientation.VERTICAL,
+                 spacing=0,
+                 padding=0,
+                 show_spinner=False):
         FramedBox.__init__(self, Gtk.Orientation.VERTICAL, spacing, padding)
+        # make the header
         self.header = Gtk.Box.new(Gtk.Orientation.HORIZONTAL, spacing)
         self.header_alignment = Gtk.Alignment()
         self.header_alignment.add(self.header)
         self.box.pack_start(self.header_alignment, False, False, 0)
+        # make the content box
         self.content_box = Gtk.Box.new(orientation, spacing)
-        self.box.add(self.content_box)
+        # and a spinner (to be used only if needed)
+        # TODO: cosmetic tweak needed - draw a line at the top of the spinner
+        #       area so that the header has a proper border
+        self.spinner = Gtk.Spinner()
+        self.spinner.set_size_request(32, 32)
+        self.spinner.set_valign(Gtk.Align.CENTER)
+        self.spinner.set_halign(Gtk.Align.CENTER)
+        # finally, a notebook for the spinner and the content box to share
+        self.spinner_notebook = Gtk.Notebook()
+        self.spinner_notebook.set_show_tabs(False)
+        self.spinner_notebook.set_show_border(False)
+        self.spinner_notebook.append_page(self.content_box, None)
+        self.spinner_notebook.append_page(self.spinner, None)
+        self.box.add(self.spinner_notebook)
         return
 
     def on_draw(self, cr):
@@ -523,6 +545,16 @@
 
     def pack_end(self, *args, **kwargs):
         return self.content_box.pack_end(*args, **kwargs)
+        
+    def show_spinner(self):
+        self.spinner.start()
+        self.spinner.show()
+        self.spinner_notebook.set_current_page(self.SPINNER)
+            
+    def hide_spinner(self):
+        self.spinner.stop()
+        self.spinner.hide()
+        self.spinner_notebook.set_current_page(self.CONTENT)
 
     # XXX: non-functional with current code...
     #~ def set_header_expand(self, expand):
@@ -553,7 +585,7 @@
         self.title.set_markup(self.MARKUP % label)
         return
 
-    def header_implements_more_button(self, callback=None):
+    def header_implements_more_button(self):
         if not hasattr(self, "more"):
             self.more = MoreLink()
             self.header.pack_end(self.more, False, False, 0)

=== modified file 'test/gtk3/test_catview.py'
--- test/gtk3/test_catview.py	2012-01-16 14:42:49 +0000
+++ test/gtk3/test_catview.py	2012-01-24 23:32:27 +0000
@@ -13,14 +13,14 @@
         #print "**************", subcatview, category
         self._cat = category
     
-    def test_subcatview_toprated(self):
+    def test_subcatview_top_rated(self):
         from softwarecenter.ui.gtk3.views.catview_gtk import get_test_window_catview
         # get the widgets we need
         win = get_test_window_catview()
         lobby = win.get_data("lobby")
-        # test clicking toprated
+        # test clicking top_rated
         lobby.connect("category-selected", self._on_category_selected)
-        lobby.toprated_frame.more.clicked()
+        lobby.top_rated_frame.more.clicked()
         self._p()
         self.assertNotEqual(self._cat, None)
         self.assertEqual(self._cat.name, "Top Rated")
@@ -33,7 +33,7 @@
         lobby = win.get_data("lobby")
         # test clicking new
         lobby.connect("category-selected", self._on_category_selected)
-        lobby.new_frame.more.clicked()
+        lobby.whats_new_frame.more.clicked()
         self._p()
         self.assertNotEqual(self._cat, None)
         # encoding is utf-8 (since r2218, see category.py)
@@ -74,7 +74,7 @@
         win.show()
         # test visibility
         self._p()
-        self.assertFalse(view.new_frame.get_property("visible"))
+        self.assertFalse(view.whats_new_frame.get_property("visible"))
         self._p()
 
     def _p(self):

